Index: /main/waeup.futminna/trunk/src/waeup/futminna/applicants/browser.py
===================================================================
--- /main/waeup.futminna/trunk/src/waeup/futminna/applicants/browser.py	(revision 8840)
+++ /main/waeup.futminna/trunk/src/waeup/futminna/applicants/browser.py	(revision 8841)
@@ -44,14 +44,4 @@
     UG_OMIT_RESULT_SLIP_FIELDS)
 from waeup.futminna.interfaces import MessageFactory as _
-
-#class RequestCallbackActionButton(RequestCallbackActionButton):
-#    """ Display the base package callback button in custom pages.
-#    """
-#    grok.context(ICustomApplicantOnlinePayment)
-
-#class CustomOnlinePaymentCallbackPage(OnlinePaymentCallbackPage):
-#    """ Activate callback simulation view
-#    """
-#    grok.context(ICustomApplicantOnlinePayment)
 
 class CustomOnlinePaymentBreadcrumb(OnlinePaymentBreadcrumb):
@@ -174,10 +164,4 @@
     form_fields[
         'payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
-    grok.template('payment_view')
-
-    @property
-    def transaction_code(self):
-        tcode = self.context.p_id
-        return tcode[len(tcode)-8:len(tcode)]
 
 class CustomApplicationFeePaymentAddPage(ApplicationFeePaymentAddPage):
@@ -193,15 +177,2 @@
     form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
-
-    @property
-    def note(self):
-        if self.context.p_state == 'paid':
-            return None
-        tcode = self.context.p_id
-        tcode = tcode[len(tcode)-8:len(tcode)]
-        amount = self.context.amount_auth
-        note = translate(_(
-            u"""<br /><br /><br />
-The tranzaction code is <strong>${a}</strong>.""",
-            mapping = {'a':tcode}))
-        return note
Index: in/waeup.futminna/trunk/src/waeup/futminna/applicants/browser_templates/payment_view.pt
===================================================================
--- /main/waeup.futminna/trunk/src/waeup/futminna/applicants/browser_templates/payment_view.pt	(revision 8840)
+++ 	(revision )
@@ -1,18 +1,0 @@
-<table class="form-table" i18n:domain="waeup.custom"
-  tal:define="files provider:files">
-  <tbody>
-    <tal:widgets content="structure provider:widgets" />
-    <tr tal:condition="python: files.replace('\n','')">
-      <td class="separator" colspan=2 i18n:translate="">
-        Uploaded Files
-      </td>
-    </tr>
-    <tal:files content="structure files" />
-    <tr>
-      <td class="fieldname">
-        <span i18n:translate="">Transaction Code</span>:
-      </td>
-      <td tal:content="view/transaction_code">TRANSACTIONCODE</td>
-    </tr>
-  </tbody>
-</table>
Index: /main/waeup.futminna/trunk/src/waeup/futminna/students/browser.py
===================================================================
--- /main/waeup.futminna/trunk/src/waeup/futminna/students/browser.py	(revision 8840)
+++ /main/waeup.futminna/trunk/src/waeup/futminna/students/browser.py	(revision 8841)
@@ -42,14 +42,4 @@
 from waeup.futminna.interfaces import MessageFactory as _
 
-#class RequestCallbackActionButton(RequestCallbackActionButton):
-#    """ Display the base package callback button in custom pages.
-#    """
-#    grok.context(ICustomStudentOnlinePayment)
-
-#class CustomOnlinePaymentCallbackPage(OnlinePaymentCallbackPage):
-#    """ Activate callback simulation view
-#    """
-#    grok.context(ICustomStudentOnlinePayment)
-
 class CustomOnlinePaymentBreadcrumb(OnlinePaymentBreadcrumb):
     """A breadcrumb for payments.
@@ -168,10 +158,4 @@
     form_fields[
         'payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
-    #grok.template('payment_view')
-
-    #@property
-    #def transaction_code(self):
-    #    tcode = self.context.p_id
-    #    return tcode[len(tcode)-8:len(tcode)]
 
 class CustomOnlinePaymentAddFormPage(OnlinePaymentAddFormPage):
@@ -201,15 +185,4 @@
     form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
-
-#    @property
-#    def note(self):
-#        tcode = self.context.p_id
-#        tcode = tcode[len(tcode)-8:len(tcode)]
-#        amount = self.context.amount_auth
-#        note = translate(_(
-#            u"""<br /><br /><br />
-#The tranzaction code is <strong>${a}</strong>.""",
-#            mapping = {'a':tcode}))
-#        return note
 
 class StudentPassportActionButton(StudentPassportActionButton):
Index: in/waeup.futminna/trunk/src/waeup/futminna/students/browser_templates/payment_view.pt
===================================================================
--- /main/waeup.futminna/trunk/src/waeup/futminna/students/browser_templates/payment_view.pt	(revision 8840)
+++ 	(revision )
@@ -1,18 +1,0 @@
-<table class="form-table" i18n:domain="waeup.custom"
-  tal:define="files provider:files">
-  <tbody>
-    <tal:widgets content="structure provider:widgets" />
-    <tr tal:condition="python: files.replace('\n','')">
-      <td class="separator" colspan=2 i18n:translate="">
-        Uploaded Files
-      </td>
-    </tr>
-    <tal:files content="structure files" />
-    <tr>
-      <td class="fieldname">
-        <span i18n:translate="">Transaction Code</span>:
-      </td>
-      <td tal:content="view/transaction_code">TRANSACTIONCODE</td>
-    </tr>
-  </tbody>
-</table>