Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/batching.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/batching.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/batching.py	(revision 8863)
@@ -25,13 +25,13 @@
 """
 from kofacustom.nigeria.students.interfaces import (
-    ICustomStudent, ICustomStudentUpdateByRegNo,
-    ICustomStudentUpdateByMatricNo
+    INigeriaStudent, INigeriaStudentUpdateByRegNo,
+    INigeriaStudentUpdateByMatricNo
     )
 from waeup.kofa.students.batching import StudentProcessor
 
-class CustomStudentProcessor(StudentProcessor):
+class NigeriaStudentProcessor(StudentProcessor):
     """A batch processor for IStudent objects.
     """
-    iface = ICustomStudent
-    iface_byregnumber = ICustomStudentUpdateByRegNo
-    iface_bymatricnumber = ICustomStudentUpdateByMatricNo
+    iface = INigeriaStudent
+    iface_byregnumber = INigeriaStudentUpdateByRegNo
+    iface_bymatricnumber = INigeriaStudentUpdateByMatricNo
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py	(revision 8863)
@@ -35,104 +35,104 @@
     PaymentReceiptActionButton, StudentPassportActionButton)
 from kofacustom.nigeria.students.interfaces import (
-    ICustomStudentBase, ICustomStudent, ICustomStudentPersonal,
-    ICustomUGStudentClearance,ICustomPGStudentClearance,
-    ICustomStudentOnlinePayment,
+    INigeriaStudentBase, INigeriaStudent, INigeriaStudentPersonal,
+    INigeriaUGStudentClearance,INigeriaPGStudentClearance,
+    INigeriaStudentOnlinePayment,
     )
 from waeup.kofa.students.workflow import ADMITTED
 from kofacustom.nigeria.interfaces import MessageFactory as _
 
-class CustomOnlinePaymentBreadcrumb(OnlinePaymentBreadcrumb):
+class NigeriaOnlinePaymentBreadcrumb(OnlinePaymentBreadcrumb):
     """A breadcrumb for payments.
     """
-    grok.context(ICustomStudentOnlinePayment)
+    grok.context(INigeriaStudentOnlinePayment)
 
 class PaymentReceiptActionButton(PaymentReceiptActionButton):
     grok.order(4)
-    grok.context(ICustomStudentOnlinePayment)
-
-class CustomStudentBaseManageFormPage(StudentBaseManageFormPage):
+    grok.context(INigeriaStudentOnlinePayment)
+
+class NigeriaStudentBaseManageFormPage(StudentBaseManageFormPage):
     """ View to manage student base data
     """
-    form_fields = grok.AutoFields(ICustomStudentBase).omit('student_id')
-
-class CustomStudentBaseEditFormPage(StudentBaseEditFormPage):
+    form_fields = grok.AutoFields(INigeriaStudentBase).omit('student_id')
+
+class NigeriaStudentBaseEditFormPage(StudentBaseEditFormPage):
     """ View to edit student base data
     """
-    form_fields = grok.AutoFields(ICustomStudentBase).select(
+    form_fields = grok.AutoFields(INigeriaStudentBase).select(
         'email', 'phone')
 
 
-class CustomStudentPersonalDisplayFormPage(StudentPersonalDisplayFormPage):
+class NigeriaStudentPersonalDisplayFormPage(StudentPersonalDisplayFormPage):
     """ Page to display student personal data
     """
-    grok.context(ICustomStudent)
-    form_fields = grok.AutoFields(ICustomStudentPersonal)
+    grok.context(INigeriaStudent)
+    form_fields = grok.AutoFields(INigeriaStudentPersonal)
     form_fields['perm_address'].custom_widget = BytesDisplayWidget
 
 
-class CustomStudentPersonalEditFormPage(StudentPersonalEditFormPage):
+class NigeriaStudentPersonalEditFormPage(StudentPersonalEditFormPage):
     """ Page to edit personal data
     """
-    form_fields = grok.AutoFields(ICustomStudentPersonal)
-
-
-class CustomStudentClearanceDisplayFormPage(StudentClearanceDisplayFormPage):
+    form_fields = grok.AutoFields(INigeriaStudentPersonal)
+
+
+class NigeriaStudentClearanceDisplayFormPage(StudentClearanceDisplayFormPage):
     """ Page to display student clearance data
     """
-    grok.context(ICustomStudent)
-
-    @property
-    def form_fields(self):
-        cm = getattr(self.context,'current_mode', None)
-        if cm is not None and cm.startswith('pg'):
-            form_fields = grok.AutoFields(
-                ICustomPGStudentClearance).omit('clearance_locked')
-        else:
-            form_fields = grok.AutoFields(
-                ICustomUGStudentClearance).omit('clearance_locked')
-        return form_fields
-
-class CustomExportPDFClearanceSlipPage(ExportPDFClearanceSlipPage):
+    grok.context(INigeriaStudent)
+
+    @property
+    def form_fields(self):
+        cm = getattr(self.context,'current_mode', None)
+        if cm is not None and cm.startswith('pg'):
+            form_fields = grok.AutoFields(
+                INigeriaPGStudentClearance).omit('clearance_locked')
+        else:
+            form_fields = grok.AutoFields(
+                INigeriaUGStudentClearance).omit('clearance_locked')
+        return form_fields
+
+class NigeriaExportPDFClearanceSlipPage(ExportPDFClearanceSlipPage):
     """Deliver a PDF slip of the context.
     """
-    grok.context(ICustomStudent)
-
-    @property
-    def form_fields(self):
-        cm = getattr(self.context,'current_mode', None)
-        if cm is not None and cm.startswith('pg'):
-            form_fields = grok.AutoFields(
-                ICustomPGStudentClearance).omit('clearance_locked')
-        else:
-            form_fields = grok.AutoFields(
-                ICustomUGStudentClearance).omit('clearance_locked')
-        return form_fields
-
-class CustomStudentClearanceManageFormPage(StudentClearanceManageFormPage):
+    grok.context(INigeriaStudent)
+
+    @property
+    def form_fields(self):
+        cm = getattr(self.context,'current_mode', None)
+        if cm is not None and cm.startswith('pg'):
+            form_fields = grok.AutoFields(
+                INigeriaPGStudentClearance).omit('clearance_locked')
+        else:
+            form_fields = grok.AutoFields(
+                INigeriaUGStudentClearance).omit('clearance_locked')
+        return form_fields
+
+class NigeriaStudentClearanceManageFormPage(StudentClearanceManageFormPage):
     """ Page to edit student clearance data
     """
-    grok.context(ICustomStudent)
-
-    @property
-    def form_fields(self):
-        cm = getattr(self.context,'current_mode', None)
-        if cm is not None and cm.startswith('pg'):
-            form_fields = grok.AutoFields(ICustomPGStudentClearance)
-        else:
-            form_fields = grok.AutoFields(ICustomUGStudentClearance)
-        return form_fields
-
-class CustomStudentClearanceEditFormPage(StudentClearanceEditFormPage):
+    grok.context(INigeriaStudent)
+
+    @property
+    def form_fields(self):
+        cm = getattr(self.context,'current_mode', None)
+        if cm is not None and cm.startswith('pg'):
+            form_fields = grok.AutoFields(INigeriaPGStudentClearance)
+        else:
+            form_fields = grok.AutoFields(INigeriaUGStudentClearance)
+        return form_fields
+
+class NigeriaStudentClearanceEditFormPage(StudentClearanceEditFormPage):
     """ View to edit student clearance data by student
     """
-    grok.context(ICustomStudent)
-
-    @property
-    def form_fields(self):
-        cm = getattr(self.context,'current_mode', None)
-        if cm is not None and cm.startswith('pg'):
-            form_fields = grok.AutoFields(ICustomPGStudentClearance).omit('clearance_locked')
-        else:
-            form_fields = grok.AutoFields(ICustomUGStudentClearance).omit('clearance_locked')
+    grok.context(INigeriaStudent)
+
+    @property
+    def form_fields(self):
+        cm = getattr(self.context,'current_mode', None)
+        if cm is not None and cm.startswith('pg'):
+            form_fields = grok.AutoFields(INigeriaPGStudentClearance).omit('clearance_locked')
+        else:
+            form_fields = grok.AutoFields(INigeriaUGStudentClearance).omit('clearance_locked')
         return form_fields
 
@@ -149,9 +149,9 @@
         return False
 
-class CustomOnlinePaymentDisplayFormPage(OnlinePaymentDisplayFormPage):
+class NigeriaOnlinePaymentDisplayFormPage(OnlinePaymentDisplayFormPage):
     """ Page to view an online payment ticket
     """
-    grok.context(ICustomStudentOnlinePayment)
-    form_fields = grok.AutoFields(ICustomStudentOnlinePayment)
+    grok.context(INigeriaStudentOnlinePayment)
+    form_fields = grok.AutoFields(INigeriaStudentOnlinePayment)
     form_fields[
         'creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
@@ -159,11 +159,11 @@
         'payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
 
-class CustomOnlinePaymentAddFormPage(OnlinePaymentAddFormPage):
+class NigeriaOnlinePaymentAddFormPage(OnlinePaymentAddFormPage):
     """ Page to add an online payment ticket
     """
-    form_fields = grok.AutoFields(ICustomStudentOnlinePayment).select(
+    form_fields = grok.AutoFields(INigeriaStudentOnlinePayment).select(
         'p_category')
 
-class CustomOnlinePaymentFakeApprovePage(OnlinePaymentFakeApprovePage):
+class NigeriaOnlinePaymentFakeApprovePage(OnlinePaymentFakeApprovePage):
     """ Disable payment approval view for students.
 
@@ -178,9 +178,9 @@
         return
 
-class CustomExportPDFPaymentSlipPage(ExportPDFPaymentSlipPage):
+class NigeriaExportPDFPaymentSlipPage(ExportPDFPaymentSlipPage):
     """Deliver a PDF slip of the context.
     """
-    grok.context(ICustomStudentOnlinePayment)
-    form_fields = grok.AutoFields(ICustomStudentOnlinePayment)
+    grok.context(INigeriaStudentOnlinePayment)
+    form_fields = grok.AutoFields(INigeriaStudentOnlinePayment)
     form_fields['creation_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
@@ -196,5 +196,5 @@
         return self.view.url(self.view.context, self.target)
 
-class CustomStudentFilesUploadPage(StudentFilesUploadPage):
+class NigeriaStudentFilesUploadPage(StudentFilesUploadPage):
     """ View to upload passport picture.
 
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/interfaces.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/interfaces.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/interfaces.py	(revision 8863)
@@ -32,8 +32,8 @@
     high_qual, high_grade, exam_types, LGASource)
 from kofacustom.nigeria.interfaces import MessageFactory as _
-from kofacustom.nigeria.payments.interfaces import ICustomOnlinePayment
-
-
-class ICustomStudentBase(IStudentBase):
+from kofacustom.nigeria.payments.interfaces import INigeriaOnlinePayment
+
+
+class INigeriaStudentBase(IStudentBase):
     """Representation of student base data.
 
@@ -47,5 +47,5 @@
         )
 
-class ICustomStudentPersonal(IStudentPersonal):
+class INigeriaStudentPersonal(IStudentPersonal):
     """Student personal data.
 
@@ -61,5 +61,5 @@
         )
 
-class ICustomUGStudentClearance(IUGStudentClearance):
+class INigeriaUGStudentClearance(IUGStudentClearance):
     """Representation of ug student clearance data.
 
@@ -220,5 +220,5 @@
 
 
-class ICustomPGStudentClearance(ICustomUGStudentClearance):
+class INigeriaPGStudentClearance(INigeriaUGStudentClearance):
     """Representation of pg student clearance data.
 
@@ -345,21 +345,21 @@
 
 
-class ICustomStudent(ICustomStudentBase,ICustomUGStudentClearance,
-    ICustomPGStudentClearance,ICustomStudentPersonal):
+class INigeriaStudent(INigeriaStudentBase,INigeriaUGStudentClearance,
+    INigeriaPGStudentClearance,INigeriaStudentPersonal):
     """Representation of a student.
 
     """
 
-class ICustomStudentStudyCourse(IStudentStudyCourse):
+class INigeriaStudentStudyCourse(IStudentStudyCourse):
     """A container for student study levels.
 
     """
 
-class ICustomStudentStudyLevel(IStudentStudyLevel):
+class INigeriaStudentStudyLevel(IStudentStudyLevel):
     """A container for course tickets.
 
     """
 
-class ICustomStudentOnlinePayment(ICustomOnlinePayment):
+class INigeriaStudentOnlinePayment(INigeriaOnlinePayment):
     """A student payment via payment gateways.
 
@@ -374,13 +374,13 @@
         )
 
-ICustomStudentOnlinePayment['p_level'].order = ICustomStudentOnlinePayment[
+INigeriaStudentOnlinePayment['p_level'].order = INigeriaStudentOnlinePayment[
     'p_session'].order
 
-class ICustomCourseTicket(ICourseTicket):
+class INigeriaCourseTicket(ICourseTicket):
     """A course ticket.
 
     """
 
-class ICustomStudentUpdateByRegNo(ICustomStudent):
+class INigeriaStudentUpdateByRegNo(INigeriaStudent):
     """Representation of a student. Skip regular reg_number validation.
 
@@ -391,5 +391,5 @@
         )
 
-class ICustomStudentUpdateByMatricNo(ICustomStudent):
+class INigeriaStudentUpdateByMatricNo(INigeriaStudent):
     """Representation of a student. Skip regular matric_number validation.
 
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/payments.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/payments.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/payments.py	(revision 8863)
@@ -26,7 +26,7 @@
     StudentOnlinePayment, StudentOnlinePaymentFactory)
 from waeup.kofa.utils.helpers import attrs_to_fields
-from kofacustom.nigeria.students.interfaces import ICustomStudentOnlinePayment
+from kofacustom.nigeria.students.interfaces import INigeriaStudentOnlinePayment
 
-class CustomStudentOnlinePayment(StudentOnlinePayment):
+class NigeriaStudentOnlinePayment(StudentOnlinePayment):
     """This is a custom online payment for students.
 
@@ -36,9 +36,9 @@
     can also be accessed in the customized system.
     """
-    grok.implements(ICustomStudentOnlinePayment, IStudentNavigation)
-    grok.provides(ICustomStudentOnlinePayment)
+    grok.implements(INigeriaStudentOnlinePayment, IStudentNavigation)
+    grok.provides(INigeriaStudentOnlinePayment)
 
     def __init__(self):
-        super(CustomStudentOnlinePayment, self).__init__()
+        super(NigeriaStudentOnlinePayment, self).__init__()
         return
 
@@ -47,13 +47,13 @@
         return self.__parent__.__parent__
 
-CustomStudentOnlinePayment = attrs_to_fields(CustomStudentOnlinePayment)
+NigeriaStudentOnlinePayment = attrs_to_fields(NigeriaStudentOnlinePayment)
 
-class CustomStudentOnlinePaymentFactory(StudentOnlinePaymentFactory):
+class NigeriaStudentOnlinePaymentFactory(StudentOnlinePaymentFactory):
     """A factory for student online payments.
     """
 
     def __call__(self, *args, **kw):
-        return CustomStudentOnlinePayment()
+        return NigeriaStudentOnlinePayment()
 
     def getInterfaces(self):
-        return implementedBy(CustomStudentOnlinePayment)
+        return implementedBy(NigeriaStudentOnlinePayment)
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/student.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/student.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/student.py	(revision 8863)
@@ -23,13 +23,13 @@
 from waeup.kofa.utils.helpers import attrs_to_fields
 from waeup.kofa.students.student import Student, StudentFactory
-from kofacustom.nigeria.students.interfaces import ICustomStudent, IStudentNavigation
+from kofacustom.nigeria.students.interfaces import INigeriaStudent, IStudentNavigation
 
 
-class CustomStudent(Student):
+class NigeriaStudent(Student):
     """This is a student container for the various objects
     owned by students.
     """
-    grok.implements(ICustomStudent, IStudentNavigation)
-    grok.provides(ICustomStudent)
+    grok.implements(INigeriaStudent, IStudentNavigation)
+    grok.provides(INigeriaStudent)
 
 
@@ -38,13 +38,13 @@
 # ourselves and as a bonus we get free validation when an attribute is
 # set.
-CustomStudent = attrs_to_fields(CustomStudent)
+NigeriaStudent = attrs_to_fields(NigeriaStudent)
 
-class CustomStudentFactory(StudentFactory):
+class NigeriaStudentFactory(StudentFactory):
     """A factory for students.
     """
 
     def __call__(self, *args, **kw):
-        return CustomStudent()
+        return NigeriaStudent()
 
     def getInterfaces(self):
-        return implementedBy(CustomStudent)
+        return implementedBy(NigeriaStudent)
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/studycourse.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/studycourse.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/studycourse.py	(revision 8863)
@@ -27,12 +27,12 @@
 from waeup.kofa.students.workflow import CLEARED, RETURNING, PAID
 from kofacustom.nigeria.students.interfaces import (
-    ICustomStudentStudyCourse, IStudentNavigation)
+    INigeriaStudentStudyCourse, IStudentNavigation)
 
-class CustomStudentStudyCourse(StudentStudyCourse):
+class NigeriaStudentStudyCourse(StudentStudyCourse):
     """This is a container for study levels.
     """
 
-    grok.implements(ICustomStudentStudyCourse, IStudentNavigation)
-    grok.provides(ICustomStudentStudyCourse)
+    grok.implements(INigeriaStudentStudyCourse, IStudentNavigation)
+    grok.provides(INigeriaStudentStudyCourse)
 
     @property
@@ -60,13 +60,13 @@
         return False
 
-CustomStudentStudyCourse = attrs_to_fields(CustomStudentStudyCourse)
+NigeriaStudentStudyCourse = attrs_to_fields(NigeriaStudentStudyCourse)
 
-class CustomStudentStudyCourseFactory(StudentStudyCourseFactory):
+class NigeriaStudentStudyCourseFactory(StudentStudyCourseFactory):
     """A factory for student study courses.
     """
 
     def __call__(self, *args, **kw):
-        return CustomStudentStudyCourse()
+        return NigeriaStudentStudyCourse()
 
     def getInterfaces(self):
-        return implementedBy(CustomStudentStudyCourse)
+        return implementedBy(NigeriaStudentStudyCourse)
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/studylevel.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/studylevel.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/studylevel.py	(revision 8863)
@@ -28,26 +28,26 @@
     CourseTicketFactory, StudentStudyLevelFactory)
 from kofacustom.nigeria.students.interfaces import (
-    ICustomStudentStudyLevel, IStudentNavigation, ICustomCourseTicket)
+    INigeriaStudentStudyLevel, IStudentNavigation, INigeriaCourseTicket)
 
 
-class CustomStudentStudyLevel(StudentStudyLevel):
+class NigeriaStudentStudyLevel(StudentStudyLevel):
     """This is a container for course tickets.
     """
-    grok.implements(ICustomStudentStudyLevel, IStudentNavigation)
-    grok.provides(ICustomStudentStudyLevel)
+    grok.implements(INigeriaStudentStudyLevel, IStudentNavigation)
+    grok.provides(INigeriaStudentStudyLevel)
 
-CustomStudentStudyLevel = attrs_to_fields(CustomStudentStudyLevel)
+NigeriaStudentStudyLevel = attrs_to_fields(NigeriaStudentStudyLevel)
 
-class CustomStudentStudyLevelFactory(StudentStudyLevelFactory):
+class NigeriaStudentStudyLevelFactory(StudentStudyLevelFactory):
     """A factory for student study levels.
     """
 
     def __call__(self, *args, **kw):
-        return CustomStudentStudyLevel()
+        return NigeriaStudentStudyLevel()
 
     def getInterfaces(self):
-        return implementedBy(CustomStudentStudyLevel)
+        return implementedBy(NigeriaStudentStudyLevel)
 
-class CustomCourseTicket(CourseTicket):
+class NigeriaCourseTicket(CourseTicket):
     """This is a course ticket which allows the
     student to attend the course. Lecturers will enter scores and more at
@@ -59,16 +59,16 @@
     triggered actions on course tickets.
     """
-    grok.implements(ICustomCourseTicket, IStudentNavigation)
-    grok.provides(ICustomCourseTicket)
+    grok.implements(INigeriaCourseTicket, IStudentNavigation)
+    grok.provides(INigeriaCourseTicket)
 
-CustomCourseTicket = attrs_to_fields(CustomCourseTicket)
+NigeriaCourseTicket = attrs_to_fields(NigeriaCourseTicket)
 
-class CustomCourseTicketFactory(CourseTicketFactory):
+class NigeriaCourseTicketFactory(CourseTicketFactory):
     """A factory for student study levels.
     """
 
     def __call__(self, *args, **kw):
-        return CustomCourseTicket()
+        return NigeriaCourseTicket()
 
     def getInterfaces(self):
-        return implementedBy(CustomCourseTicket)
+        return implementedBy(NigeriaCourseTicket)
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_browser.py	(revision 8863)
@@ -31,9 +31,9 @@
 from waeup.kofa.students.batching import StudentProcessor
 from waeup.kofa.students.interfaces import IStudentsUtils
-from kofacustom.nigeria.students.batching import CustomStudentProcessor
+from kofacustom.nigeria.students.batching import NigeriaStudentProcessor
 from kofacustom.nigeria.testing import FunctionalLayer
 from kofacustom.nigeria.students.interfaces import (
-    ICustomStudentStudyCourse, ICustomStudent,
-    ICustomStudentStudyLevel, ICustomCourseTicket)
+    INigeriaStudentStudyCourse, INigeriaStudent,
+    INigeriaStudentStudyLevel, INigeriaCourseTicket)
 
 
@@ -69,5 +69,5 @@
 
         self.processor_base = StudentProcessor()
-        self.processor = CustomStudentProcessor()
+        self.processor = NigeriaStudentProcessor()
         self.workdir = tempfile.mkdtemp()
         self.csv_file = os.path.join(self.workdir, 'sample_student_data.csv')
@@ -108,11 +108,11 @@
         # Let's see if objects created in the customized
         # portal really implement the customized interfaces
-        verify.verifyObject(ICustomStudent, self.student)
+        verify.verifyObject(INigeriaStudent, self.student)
         verify.verifyObject(
-            ICustomStudentStudyCourse, self.student['studycourse'])
+            INigeriaStudentStudyCourse, self.student['studycourse'])
         studylevel = createObject(u'waeup.StudentStudyLevel')
-        verify.verifyObject(ICustomStudentStudyLevel, studylevel)
+        verify.verifyObject(INigeriaStudentStudyLevel, studylevel)
         ticket = createObject(u'waeup.CourseTicket')
-        verify.verifyObject(ICustomCourseTicket, ticket)
+        verify.verifyObject(INigeriaCourseTicket, ticket)
         IWorkflowState(self.student).setState('returning')
         # Let's see if next_session_allowed works as expected
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_student.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_student.py	(revision 8862)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/tests/test_student.py	(revision 8863)
@@ -22,106 +22,106 @@
 from zope.interface import verify
 from waeup.kofa.testing import FunctionalTestCase
-from kofacustom.nigeria.students.student import CustomStudent, CustomStudentFactory
+from kofacustom.nigeria.students.student import NigeriaStudent, NigeriaStudentFactory
 from kofacustom.nigeria.students.studycourse import (
-    CustomStudentStudyCourse, CustomStudentStudyCourseFactory)
+    NigeriaStudentStudyCourse, NigeriaStudentStudyCourseFactory)
 from kofacustom.nigeria.students.studylevel import (
-    CustomStudentStudyLevel, CustomCourseTicket,
-    CustomStudentStudyLevelFactory,
-    CustomCourseTicketFactory)
+    NigeriaStudentStudyLevel, NigeriaCourseTicket,
+    NigeriaStudentStudyLevelFactory,
+    NigeriaCourseTicketFactory)
 from kofacustom.nigeria.students.interfaces import (
-    ICustomStudent, ICustomStudentStudyCourse,
-    ICustomStudentStudyLevel, ICustomCourseTicket)
+    INigeriaStudent, INigeriaStudentStudyCourse,
+    INigeriaStudentStudyLevel, INigeriaCourseTicket)
 from kofacustom.nigeria.testing import FunctionalLayer
 
 
-class CustomStudentFactoryTest(FunctionalTestCase):
+class NigeriaStudentFactoryTest(FunctionalTestCase):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(CustomStudentFactoryTest, self).setUp()
-        self.factory = CustomStudentFactory()
+        super(NigeriaStudentFactoryTest, self).setUp()
+        self.factory = NigeriaStudentFactory()
 
     def tearDown(self):
-        super(CustomStudentFactoryTest, self).tearDown()
+        super(NigeriaStudentFactoryTest, self).tearDown()
 
     def test_interfaces(self):
-        verify.verifyClass(IFactory, CustomStudentFactory)
+        verify.verifyClass(IFactory, NigeriaStudentFactory)
         verify.verifyObject(IFactory, self.factory)
 
     def test_factory(self):
         obj = self.factory()
-        assert isinstance(obj, CustomStudent)
+        assert isinstance(obj, NigeriaStudent)
 
     def test_getInterfaces(self):
         implemented_by = self.factory.getInterfaces()
-        assert implemented_by.isOrExtends(ICustomStudent)
+        assert implemented_by.isOrExtends(INigeriaStudent)
 
-class CustomStudentStudyCourseFactoryTest(FunctionalTestCase):
+class NigeriaStudentStudyCourseFactoryTest(FunctionalTestCase):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(CustomStudentStudyCourseFactoryTest, self).setUp()
-        self.factory = CustomStudentStudyCourseFactory()
+        super(NigeriaStudentStudyCourseFactoryTest, self).setUp()
+        self.factory = NigeriaStudentStudyCourseFactory()
 
     def tearDown(self):
-        super(CustomStudentStudyCourseFactoryTest, self).tearDown()
+        super(NigeriaStudentStudyCourseFactoryTest, self).tearDown()
 
     def test_interfaces(self):
-        verify.verifyClass(IFactory, CustomStudentStudyCourseFactory)
+        verify.verifyClass(IFactory, NigeriaStudentStudyCourseFactory)
         verify.verifyObject(IFactory, self.factory)
 
     def test_factory(self):
         obj = self.factory()
-        assert isinstance(obj, CustomStudentStudyCourse)
+        assert isinstance(obj, NigeriaStudentStudyCourse)
 
     def test_getInterfaces(self):
         implemented_by = self.factory.getInterfaces()
-        assert implemented_by.isOrExtends(ICustomStudentStudyCourse)
+        assert implemented_by.isOrExtends(INigeriaStudentStudyCourse)
 
-class CustomStudentStudyLevelFactoryTest(FunctionalTestCase):
+class NigeriaStudentStudyLevelFactoryTest(FunctionalTestCase):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(CustomStudentStudyLevelFactoryTest, self).setUp()
-        self.factory = CustomStudentStudyLevelFactory()
+        super(NigeriaStudentStudyLevelFactoryTest, self).setUp()
+        self.factory = NigeriaStudentStudyLevelFactory()
 
     def tearDown(self):
-        super(CustomStudentStudyLevelFactoryTest, self).tearDown()
+        super(NigeriaStudentStudyLevelFactoryTest, self).tearDown()
 
     def test_interfaces(self):
-        verify.verifyClass(IFactory, CustomStudentStudyLevelFactory)
+        verify.verifyClass(IFactory, NigeriaStudentStudyLevelFactory)
         verify.verifyObject(IFactory, self.factory)
 
     def test_factory(self):
         obj = self.factory()
-        assert isinstance(obj, CustomStudentStudyLevel)
+        assert isinstance(obj, NigeriaStudentStudyLevel)
 
     def test_getInterfaces(self):
         implemented_by = self.factory.getInterfaces()
-        assert implemented_by.isOrExtends(ICustomStudentStudyLevel)
+        assert implemented_by.isOrExtends(INigeriaStudentStudyLevel)
 
-class CustomCourseTicketFactoryTest(FunctionalTestCase):
+class NigeriaCourseTicketFactoryTest(FunctionalTestCase):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(CustomCourseTicketFactoryTest, self).setUp()
-        self.factory = CustomCourseTicketFactory()
+        super(NigeriaCourseTicketFactoryTest, self).setUp()
+        self.factory = NigeriaCourseTicketFactory()
 
     def tearDown(self):
-        super(CustomCourseTicketFactoryTest, self).tearDown()
+        super(NigeriaCourseTicketFactoryTest, self).tearDown()
 
     def test_interfaces(self):
-        verify.verifyClass(IFactory, CustomCourseTicketFactory)
+        verify.verifyClass(IFactory, NigeriaCourseTicketFactory)
         verify.verifyObject(IFactory, self.factory)
 
     def test_factory(self):
         obj = self.factory()
-        assert isinstance(obj, CustomCourseTicket)
+        assert isinstance(obj, NigeriaCourseTicket)
 
     def test_getInterfaces(self):
         implemented_by = self.factory.getInterfaces()
-        assert implemented_by.isOrExtends(ICustomCourseTicket)
+        assert implemented_by.isOrExtends(INigeriaCourseTicket)