Index: main/waeup.futminna/trunk/buildout.cfg
===================================================================
--- main/waeup.futminna/trunk/buildout.cfg	(revision 8894)
+++ main/waeup.futminna/trunk/buildout.cfg	(revision 8895)
@@ -1,4 +1,11 @@
 [buildout]
-develop = . waeup.kofa kofacustom.nigeria
+# See http://pypi.python.org/pypi/mr.developer for details
+extensions = mr.developer
+auto-checkout = waeup.kofa kofacustom.nigeria
+# We cannot use 'src' (the default) as the checked out projects won't
+# work properly with paster (paster looks up any upper directory
+# egg-info dirs and then complains about not-available packages).
+sources-dir = sources
+develop = .
 parts =
     eggbasket
@@ -31,4 +38,8 @@
 # unless you specify an eggs-directory option here.
 
+[sources]
+waeup.kofa = svn https://svn.waeup.org/repos/main/waeup.kofa/trunk
+kofacustom.nigeria = svn https://svn.waeup.org/repos/main/kofacustom.nigeria/trunk
+
 [kofa_params]
 ## Basic parameters for deployment.
@@ -60,4 +71,5 @@
        repoze.profile
        ZODB3
+interpreter = python-console
 
 [kofactl]
Index: main/waeup.futminna/trunk/src/waeup/futminna/configure.zcml
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/configure.zcml	(revision 8894)
+++ main/waeup.futminna/trunk/src/waeup/futminna/configure.zcml	(revision 8895)
@@ -1,7 +1,11 @@
-<configure xmlns="http://namespaces.zope.org/zope">
+  <configure xmlns="http://namespaces.zope.org/zope"
+           xmlns:grok="http://namespaces.zope.org/grok">
+  <include package="waeup.futminna" file="locales.zcml" />
 
-  <include package="waeup.futminna" file="locales.zcml" />
-  <include package="grok" />
-  <includeOverrides package="waeup.futminna" file="overrides.zcml" />
+  <!-- kofacustom.nigeria configures everything we basically need.
+  -->
+  <include package="kofacustom.nigeria" />
+
+  <grok:grok package="." />
 
 </configure>
Index: main/waeup.futminna/trunk/src/waeup/futminna/ftesting.zcml
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/ftesting.zcml	(revision 8894)
+++ main/waeup.futminna/trunk/src/waeup/futminna/ftesting.zcml	(revision 8895)
@@ -6,7 +6,6 @@
    >
 
-  <include package="grok" />
-  <includeOverrides package="waeup.futminna" />
-  <includeOverrides package="waeup.futminna" file="mail.zcml"/>
+  <include package="waeup.futminna" />
+  <include package="waeup.futminna" file="mail.zcml"/>
 
   <!-- Where should the datacenter reside by default? -->
Index: main/waeup.futminna/trunk/src/waeup/futminna/overrides.zcml
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/overrides.zcml	(revision 8894)
+++ 	(revision )
@@ -1,15 +1,0 @@
-<configure xmlns="http://namespaces.zope.org/zope"
-           xmlns:grok="http://namespaces.zope.org/grok">
-  <includeDependencies package="." />
-  <grok:grok package="." />
-
-  <!-- Register edit widget for PhoneNumbers -->
-  <adapter
-      for="waeup.kofa.schema.interfaces.IPhoneNumber
-           zope.publisher.interfaces.browser.IBrowserRequest"
-      provides="zope.formlib.interfaces.ISimpleInputWidget"
-      factory="waeup.futminna.widgets.phonewidget.CustomPhoneWidget"
-      permission="zope.Public"
-      />
-
-</configure>
Index: main/waeup.futminna/trunk/src/waeup/futminna/widgets/__init__.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/widgets/__init__.py	(revision 8894)
+++ 	(revision )
@@ -1,1 +1,0 @@
-# Make this a package.
Index: main/waeup.futminna/trunk/src/waeup/futminna/widgets/phonewidget.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/widgets/phonewidget.py	(revision 8894)
+++ 	(revision )
@@ -1,28 +1,0 @@
-## $Id$
-##
-## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
-## This program is free software; you can redistribute it and/or modify
-## it under the terms of the GNU General Public License as published by
-## the Free Software Foundation; either version 2 of the License, or
-## (at your option) any later version.
-##
-## This program is distributed in the hope that it will be useful,
-## but WITHOUT ANY WARRANTY; without even the implied warranty of
-## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-## GNU General Public License for more details.
-##
-## You should have received a copy of the GNU General Public License
-## along with this program; if not, write to the Free Software
-## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
-##
-"""
-A customized phone widget
-"""
-
-from waeup.kofa.widgets.phonewidget import PhoneWidget
-
-class CustomPhoneWidget(PhoneWidget):
-    """A phone widget without area prefix.
-    """
-    subwidget_names = ('country', 'ext')
-    bootstrap_span = 'span3'